function [f,g,h]=BDQRTIC(x)
%the CUTEr BDQRTIC problem, n must be greater or equal to 4
  global count;

  n=size(x,1);
  g=[];h=[];
  count(1)=count(1)+1;
  i=1:n-4;
  f=sum( (-4*x(i)+3).^2+(x(i).^2+2*x(i+1).^2+3*x(i+2).^2+4*x(i+3).^2+5*x(n).^2).^2 );

  if nargout>=2 
    count(2)=count(2)+1;
    i=1;
    g1  =  32*x(i)-24+...
	   (4*(x(i).^2+  2*x(i+1).^2+3*x(i+2).^2+4*x(i+3).^2+5*x(n).^2)).*x(i);

    i=2;
    g2  =  32*x(i)-24+...
	   (8*(x(i-1).^2+2*x(i).^2  +3*x(i+1).^2+4*x(i+2).^2+5*x(n).^2)+...
	    4*(x(i).^2+  2*x(i+1).^2+3*x(i+2).^2+4*x(i+3).^2+5*x(n).^2)).*x(i);
    i=3;
    g3  = 32*x(i)-24+...
	  (12*(x(i-2).^2+2*x(i-1).^2+3*x(i).^2  +4*x(i+1).^2+5*x(n).^2)+...
	   8*(x(i-1).^2+2*x(i).^2  +3*x(i+1).^2+4*x(i+2).^2+5*x(n).^2)+...
	   4*(x(i).^2+  2*x(i+1).^2+3*x(i+2).^2+4*x(i+3).^2+5*x(n).^2)).*x(i);
    
    i=4:n-4;
    gi  = 32*x(i)-24+...
	  (16*(x(i-3).^2+2*x(i-2).^2+3*x(i-1).^2+4*x(i).^2  +5*x(n).^2)+...
	   12*(x(i-2).^2+2*x(i-1).^2+3*x(i).^2  +4*x(i+1).^2+5*x(n).^2)+...
	    8*(x(i-1).^2+2*x(i).^2  +3*x(i+1).^2+4*x(i+2).^2+5*x(n).^2)+...
	    4*(x(i).^2+  2*x(i+1).^2+3*x(i+2).^2+4*x(i+3).^2+5*x(n).^2)).*x(i);
    i=n-3;
    gnm3 =(16*(x(i-3).^2+2*x(i-2).^2+3*x(i-1).^2+4*x(i).^2  +5*x(n).^2)+...
	   12*(x(i-2).^2+2*x(i-1).^2+3*x(i).^2  +4*x(i+1).^2+5*x(n).^2)+...
	   8*(x(i-1).^2+2*x(i).^2  +3*x(i+1).^2+4*x(i+2).^2+5*x(n).^2)).*x(i);
    
    i=n-2;
    gnm2 =(16*(x(i-3).^2+2*x(i-2).^2+3*x(i-1).^2+4*x(i).^2  +5*x(n).^2)+...
	    12*(x(i-2).^2+2*x(i-1).^2+3*x(i).^2  +4*x(i+1).^2+5*x(n).^2)).*x(i);
    i=n-1;
    gnm1 = (16*(x(i-3).^2+2*x(i-2).^2+3*x(i-1).^2+4*x(i).^2  +5*x(n).^2)).*x(i);
     
    i=1:n-4;
    gn   = (100*n-400)*x(n).^3+20*x(n).*sum(x(i).^2+2*x(i+1).^2+3*x(i+2).^2+4*x(i+3).^2);

    g=[g1;g2;g3;gi;gnm3;gnm2;gnm1;gn];
    end
